/*Download Manager by Sir Drink a lot (07.07.04)
Idee vom AMX Plugin amx_ejl_allsound_downloader.sma von "Ludwig van".


BESCHREIBUNG:
-------------------------
Erstellt automatisch MapName.res Dateien.
Die Eintrge werden von einer master_download.ini eingelesen, welche
Sounds, Wad-Dateien etc. sie herunterladen mssen.

Das erspart das jeweilige manuelle Anlegen einer *.res Datei.

Die master_download.ini ist folgendermaen aufgebaut:

#ALL -> Alle Sounds die danach folgen, werden in jeder *.res Datei aufgefhrt.
#MAPNAME -> Hier werden zustzlich mapspezifische Downloads wie z.B. wad Dateien aufgefhrt!

!!!VORSICHT:!!!
-------------------------
Man muss also darauf achten, dass in die master_download.ini
z.B. fr fy_iceworld dieses eingetragen wird:

#fy_iceworld
de_vegas.wad

Sonst knnen die Clients, die (natrlich auf dem Server im cstrike Verzeichnis vorhandene) Datei 
nicht herunterladen und somit diese Map nicht spielen!

WENN ALSO EINE MAP SCHON EINE EIGENE MAPNAME.RES DATEI HAT,
DANN MSSEN DIE EINTRGE AUS DIESER MAPNAME.RES IN DIE master_download.ini
BERNOMMEN WERDEN!!!!! SONST FUNKTIONIERT ES NICHT UND DIE MAP KANN VON
VIELEN CLIENTS NICHT GESPIELT WERDEN !!!!

NOTWENDIG:
-------------------------
- file_access_read und file_access_write mssen auf 1 in der adminmod.cfg gesetzt sein!
*/

#include <string>
#include <admin>
#include <adminlib>

new g_MasterDLList[MAX_TEXT_LENGTH]="addons/adminmod/config/master_download.ini";

public plugin_init(){
	new MapName[MAX_NAME_LENGTH];
	plugin_registerinfo("Download Manager","Creates *.res files automatically using a master_download.ini","1.0");
	currentmap(MapName,MAX_NAME_LENGTH);
	create_mapres(MapName);
	return PLUGIN_CONTINUE;
}

create_mapres(MapName[]){
	new Data[MAX_DATA_LENGTH];
	new MapSpecific[MAX_NAME_LENGTH];
	new ResFile[MAX_NAME_LENGTH];
	new iFileSize;
	new i;
	new iPart;
	
	snprintf(ResFile,MAX_NAME_LENGTH,"maps/%s.res",MapName);
	snprintf(MapSpecific,MAX_NAME_LENGTH,"#%s",MapName);
		
	if(fileexists(g_MasterDLList)){
		if(fileexists(ResFile)){
			resetfile(ResFile);
		}
		iFileSize=filesize(g_MasterDLList);
		for(i=0;i<=iFileSize;i++){
			readfile(g_MasterDLList,Data,i,MAX_DATA_LENGTH);
			if(strcmp(Data,"#ALL")==0 || strcmp(Data,MapSpecific)==0){
				iPart=1;
			}else if(Data[0]=='#'){
				iPart=0;
			}
			if(iPart){
				if(Data[0]!='#' && Data[0]!='/' && Data[0]!=';'){
					writefile(ResFile,Data,-1);
				}
			}			
		}
	}else{
		selfmessage("[Download-Manager] Could not read from masterfile!");
	}
}
	